<!DOCTYPE html>
<html lang="en-us">
<head>

  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="generator" content="Source Themes Academic 3.1.0">
  <meta name="generator" content="Hugo 0.50" />
  <meta name="author" content="Jeremy Jackson">

  
  
  
  
    
  
  <meta name="description" content="Fixing the bad data wedge pattern that comes from Excel being awful.">

  
  <link rel="alternate" hreflang="en-us" href="https://ackso.net/post/the-wedge-pattern/">

  


  

  

  

  
  
  
  <meta name="theme-color" content="#2962ff">
  

  
  
  
  
    
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha256-eSi1q2PG6J7g7ib17yAaWMcrr5GrtohYChqibrV7PBE=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/academicons/1.8.6/css/academicons.min.css" integrity="sha256-uFVgMKfistnJAfoCUQigIl+JfUaP47GrRKjf6CTPVmw=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.5.0/css/all.css" integrity="sha384-B4dIYHKNBt8Bc12p+WXckhzcICo0wtJAoU8YZTY5qE0Id1GSseTk6S+L3BlXeVIU" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.css" integrity="sha256-ygkqlh3CYSUri3LhQxzdcm0n1EQvH2Y+U5S2idbLtxs=" crossorigin="anonymous">

    
    
    
      
    
    
      
      
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" crossorigin="anonymous">
      
    

    

    

  

  
  
  <link rel="stylesheet" href="//fonts.googleapis.com/css?family=Montserrat:400,700|Roboto:400,400italic,700|Roboto+Mono">
  

  <link rel="stylesheet" href="/styles.css">
  

  
  
  

  
  <link rel="alternate" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  <link rel="feed" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  

  <link rel="manifest" href="/site.webmanifest">
  <link rel="icon" type="image/png" href="/img/icon.png">
  <link rel="apple-touch-icon" type="image/png" href="/img/icon-192.png">

  <link rel="canonical" href="https://ackso.net/post/the-wedge-pattern/">

  <meta property="twitter:card" content="summary_large_image">
  
  <meta property="og:site_name" content="Sometimes Jeremy Thinks">
  <meta property="og:url" content="https://ackso.net/post/the-wedge-pattern/">
  <meta property="og:title" content="The Wedge Pattern | Sometimes Jeremy Thinks">
  <meta property="og:description" content="Fixing the bad data wedge pattern that comes from Excel being awful.">
  
  
    
  <meta property="og:image" content="https://ackso.net/img/icon-192.png">
  <meta property="og:locale" content="en-us">
  
  <meta property="article:published_time" content="2017-12-16T22:30:48-07:00">
  
  <meta property="article:modified_time" content="2017-12-16T22:30:48-07:00">
  

  

  

  <title>The Wedge Pattern | Sometimes Jeremy Thinks</title>

</head>
<body id="top" data-spy="scroll" data-target="#TableOfContents" data-offset="71" >

<nav class="navbar navbar-light fixed-top navbar-expand-lg py-0" id="navbar-main">
  <div class="container">

    
      <a class="navbar-brand" href="/">Sometimes Jeremy Thinks</a>
      
      <button type="button" class="navbar-toggler" data-toggle="collapse"
              data-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
        <span><i class="fas fa-bars"></i></span>
      </button>
      

    
    <div class="collapse navbar-collapse" id="navbar">

      
      
      <ul class="navbar-nav ml-auto">
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#about">
            
            <span>Home</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#posts">
            
            <span>Posts</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#projects">
            
            <span>Projects</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#contact">
            
            <span>Contact</span>
            
          </a>
        </li>

        
        

      

        

        
      </ul>

    </div>
  </div>
</nav>


<article class="article" itemscope itemtype="http://schema.org/Article">

  












  

  
  
  
<div class="article-container pt-3">
  <h1 itemprop="name">The Wedge Pattern</h1>

  

  
    

<div class="article-metadata">

  
  
  <span itemscope itemprop="author" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>
  

  <span class="article-date">
    
    <meta content="2017-12-16 22:30:48 -0700 MST" itemprop="datePublished">
    <time datetime="2017-12-16 22:30:48 -0700 MST" itemprop="dateModified">
      2017-12-16
    </time>
  </span>
  <span itemscope itemprop="publisher" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>

  
  <span class="middot-divider"></span>
  <span class="article-reading-time">
    3 min read
  </span>
  

  
  
  <span class="middot-divider"></span>
  <a href="/post/the-wedge-pattern/#disqus_thread"></a>
  

  

  
  
<div class="share-box" aria-hidden="true">
  <ul class="share">
    <li>
      <a class="twitter"
         href="https://twitter.com/intent/tweet?text=The%20Wedge%20Pattern&amp;url=https%3a%2f%2fackso.net%2fpost%2fthe-wedge-pattern%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-twitter"></i>
      </a>
    </li>
    <li>
      <a class="facebook"
         href="https://www.facebook.com/sharer.php?u=https%3a%2f%2fackso.net%2fpost%2fthe-wedge-pattern%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-facebook-f"></i>
      </a>
    </li>
    <li>
      <a class="linkedin"
         href="https://www.linkedin.com/shareArticle?mini=true&amp;url=https%3a%2f%2fackso.net%2fpost%2fthe-wedge-pattern%2f&amp;title=The%20Wedge%20Pattern"
         target="_blank" rel="noopener">
        <i class="fab fa-linkedin-in"></i>
      </a>
    </li>
    <li>
      <a class="weibo"
         href="http://service.weibo.com/share/share.php?url=https%3a%2f%2fackso.net%2fpost%2fthe-wedge-pattern%2f&amp;title=The%20Wedge%20Pattern"
         target="_blank" rel="noopener">
        <i class="fab fa-weibo"></i>
      </a>
    </li>
    <li>
      <a class="email"
         href="mailto:?subject=The%20Wedge%20Pattern&amp;body=https%3a%2f%2fackso.net%2fpost%2fthe-wedge-pattern%2f">
        <i class="fas fa-envelope"></i>
      </a>
    </li>
  </ul>
</div>


  

</div>

    















  
</div>



  <div class="article-container">

    <div class="article-style" itemprop="articleBody">
      <p>Let&rsquo;s face it: Excel doesn&rsquo;t respect data.
Unfortunately, tons of people use it and somehow successfully make very important decisions with it.
That means that we have to live with the fallout from that if we&rsquo;re trying to use that badly
formatted data they&rsquo;re producing in meaningful ways.</p>

<p>One of the worst data patterns that comes out of Excel can be called the &ldquo;Wedge Pattern&rdquo;.
This happens when somebody just throws a bunch of data into a PivotTable and calls it &ldquo;good enough&rdquo;,
without adhering to any sort of common data standard, like repeating values down the entire column,
or having data (or headers) start in the first row of the first column.
It&rsquo;s a real problem, and when it&rsquo;s exported to CSV it looks something like this:</p>

<pre><code>,,,,,,
,&quot;Last Name&quot;,&quot;First Name&quot;,&quot;Email&quot;,&quot;Item&quot;,&quot;Quantity&quot;,&quot;Unit Price&quot;,&quot;Subtotal&quot;
,&quot;Smith&quot;,&quot;Sue&quot;,&quot;sue@email.org&quot;,&quot;Coffee&quot;,1,1.00,1.00
,,,&quot;Filters&quot;,5,1.00,5.00
,,,,,&quot;Subtotal&quot;,6.00
,&quot;Bob&quot;,,&quot;Coffee&quot;,2,1.00,2.00
,,,&quot;Filters&quot;,10,1.00,10.00
,,,,,&quot;Subtotal&quot;,12.00
,&quot;Jones&quot;,&quot;Tom&quot;,&quot;tom@email.org&quot;,&quot;Coffee&quot;,3,1.00,3.00
,,,,,&quot;Subtotal&quot;,3.00
,,&quot;Ana&quot;,&quot;ana@email.org&quot;,&quot;Coffee&quot;,8,1.00.8.00
,,,,,&quot;Subtotal&quot;,8.00
,,,,,&quot;Total&quot;,29.00
</code></pre>

<p>When it&rsquo;s broken out into a table, the badness of this pattern becomes pretty clear.
I&rsquo;m going to exclude the first row and column, since they aren&rsquo;t necessary for showing the
actual &ldquo;wedge&rdquo; shape here.</p>

<table>
<thead>
<tr>
<th>Last Name</th>
<th>First Name</th>
<th>Email</th>
<th>Item</th>
<th>Quantity</th>
<th>Unit Price</th>
<th>Subtotal</th>
</tr>
</thead>

<tbody>
<tr>
<td>Smith</td>
<td>Sue</td>
<td>sue@email.org</td>
<td>Coffee</td>
<td>1</td>
<td>1.00</td>
<td>1.00</td>
</tr>

<tr>
<td></td>
<td></td>
<td></td>
<td>Filters</td>
<td>5</td>
<td>1.00</td>
<td>5.00</td>
</tr>

<tr>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td>Subtotal</td>
<td>6.00</td>
</tr>

<tr>
<td></td>
<td>Bob</td>
<td></td>
<td>Coffee</td>
<td>2</td>
<td>1.00</td>
<td>2.00</td>
</tr>

<tr>
<td></td>
<td></td>
<td></td>
<td>Filters</td>
<td>10</td>
<td>1.00</td>
<td>10.00</td>
</tr>

<tr>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td>Subtotal</td>
<td>12.00</td>
</tr>

<tr>
<td>Jones</td>
<td>Tom</td>
<td>tom@email.org</td>
<td>Coffee</td>
<td>3</td>
<td>1.00</td>
<td>3.00</td>
</tr>

<tr>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td>Subtotal</td>
<td>3.00</td>
</tr>

<tr>
<td></td>
<td>Ana</td>
<td>ana@email.org</td>
<td>Coffee</td>
<td>8</td>
<td>1.00</td>
<td>8.00</td>
</tr>

<tr>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td>Subtotal</td>
<td>8.00</td>
</tr>

<tr>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td>Total</td>
<td>29.00</td>
</tr>
</tbody>
</table>

<p>Fortunately, a little bit of negotiating with this data in R using the <code>tidyverse</code> packages
can solve this pretty quickly.</p>

<pre><code class="language-r"># Assume the CSV has already been read in and we've already removed
# the empty first column and row, moved the headers to their proper
# place, and stuck it all in a data.frame named `dat`.
#
# We still have yet to fix the column types.

library(tidyverse)

dat &lt;-
  dat %&gt;%
  fill(`Last Name`, `First Name`)

# At this point we're doing pretty good, but we still have to deal
# with the Subtotal and Total rows. We'll fall back on `plyr` for
# this. The reason we need to go there is because of &quot;Bob&quot;.
# He doesn't have an email address, and we don't want to carry
# &quot;Sue's&quot; email address down to him. Using `ddply` will let us
# be flexible in how we handle these different things.

library(plyr)

dat &lt;- ddply(
  dat,
  c('Last Name', 'First Name'),
  function(x) {
    x &lt;- x[!is.na(x$Item), ]
    x &lt;- x %&gt;% fill(Email)
    return(x)
  }
)

dat$`Unit Price` &lt;- as_numeric(dat$`Unit Price`)
</code></pre>

<p>This one is a fairly contrived example, but more complicated specimen of this ilk exist, which
may require you to begin by filling just one or two columns, performing other operations, and
then continuing with the fill.</p>

<p>So, how can you prevent this in the first place? Evangelism. Pure and simple. Show people a
better way and make them believe that it is a better way.
However, if they&rsquo;re really that dedicated to Excel, you may not be able to sway them.</p>

<p>Good luck!</p>

    </div>

    


<div class="article-tags">
  
  <a class="badge badge-light" href="/tags/r/">R</a>
  
  <a class="badge badge-light" href="/tags/bad-data/">bad data</a>
  
  <a class="badge badge-light" href="/tags/excel-is-terrible/">Excel is terrible</a>
  
</div>



    






<div class="media author-card" itemscope itemtype="http://schema.org/Person">
  
  <img class="portrait mr-3" src="/img/portrait.jpg" itemprop="image" alt="Avatar">
  
  <div class="media-body">
    <h5 class="card-title" itemprop="name"><a href="/">Jeremy Jackson</a></h5>
    <h6 class="card-subtitle">Software Engineering and Data Science</h6>
    
    <ul class="network-icon" aria-hidden="true">
      
      
      
      
      
      
      
      
      <li>
        <a itemprop="sameAs" href="mailto:jeremy_j@ackso.net" >
          <i class="fa fa-envelope"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//twitter.com/jeremy_j_ackso" >
          <i class="fab fa-twitter"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//github.com/jeremy-j-ackso" >
          <i class="fab fa-github"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//gitlab.com/jeremy.jackson" >
          <i class="fab fa-gitlab"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//linkedin.com/in/jeremy-jackson-249878153" >
          <i class="fab fa-linkedin"></i>
        </a>
      </li>
      
    </ul>
  </div>
</div>




    
    

    

    
<section id="comments">
  <div id="disqus_thread"></div>
<script type="application/javascript">
    var disqus_config = function () {
    
    
    
    };
    (function() {
        if (["localhost", "127.0.0.1"].indexOf(window.location.hostname) != -1) {
            document.getElementById('disqus_thread').innerHTML = 'Disqus comments not available by default when the website is previewed locally.';
            return;
        }
        var d = document, s = d.createElement('script'); s.async = true;
        s.src = '//' + "ackso-net.disqus.com" + '.disqus.com/embed.js';
        s.setAttribute('data-timestamp', +new Date());
        (d.head || d.body).appendChild(s);
    })();
</script>
<noscript>Please enable JavaScript to view the <a href="https://disqus.com/?ref_noscript">comments powered by Disqus.</a></noscript>
<a href="https://disqus.com" class="dsq-brlink">comments powered by <span class="logo-disqus">Disqus</span></a>
</section>



  </div>
</article>

<div class="container">
  <footer class="site-footer">
  

  <p class="powered-by">
    &copy; 2017 Jeremy T Jackson &middot; 

    Powered by the
    <a href="https://sourcethemes.com/academic/" target="_blank" rel="noopener">Academic theme</a> for
    <a href="https://gohugo.io" target="_blank" rel="noopener">Hugo</a>.

    
    <span class="float-right" aria-hidden="true">
      <a href="#" id="back_to_top">
        <span class="button_icon">
          <i class="fas fa-chevron-up fa-2x"></i>
        </span>
      </a>
    </span>
    
  </p>
</footer>

</div>


<div id="modal" class="modal fade" role="dialog">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Cite</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <pre><code class="tex hljs"></code></pre>
      </div>
      <div class="modal-footer">
        <a class="btn btn-outline-primary my-1 js-copy-cite" href="#" target="_blank">
          <i class="fas fa-copy"></i> Copy
        </a>
        <a class="btn btn-outline-primary my-1 js-download-cite" href="#" target="_blank">
          <i class="fas fa-download"></i> Download
        </a>
        <div id="modal-error"></div>
      </div>
    </div>
  </div>
</div>

    

    
    
    
    
    <script src="/js/mathjax-config.500a6cbb2c0f345fcecc21b3116d6637aa78f1f11db8081ea581abe05390c2e8f3bbffe61be3cf0217baf785c40efceabe51050a4f007e69af94efd3643260e8.js" integrity="sha512-UApsuywPNF/OzCGzEW1mN6p48fEduAgepYGr4FOQwujzu//mG&#43;PPAhe694XEDvzqvlEFCk8AfmmvlO/TZDJg6A=="></script>
    

    
    
    
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js" integrity="sha512-+NqPlbbtM1QqiK8ZAo4Yrj2c4lNQoGv8P79DPtKzj++l5jnN39rHA/xsqn8zE9l0uSoxaCdrOgFs6yjyfbBxSg==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.imagesloaded/4.1.3/imagesloaded.pkgd.min.js" integrity="sha512-umsR78NN0D23AzgoZ11K7raBD+R6hqKojyBZs1w8WvYlsI+QuKRGBx3LFCwhatzBunCjDuJpDHwxD13sLMbpRA==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha256-VsEqElsCHSGmnmHXGQzvoWjWwoznFSZc6hs7ARLRacQ=" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.isotope/3.0.4/isotope.pkgd.min.js" integrity="sha512-VDBOIlDbuC4VWxGJNmuFRQ0Li0SKkDpmGyuhAG5LTDLd/dJ/S0WMVxriR2Y+CyPL5gzjpN4f/6iqWVBJlht0tQ==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.js" integrity="sha256-X5PoE3KU5l+JcX+w09p/wHl9AzK333C4hJ2I9S5mD4M=" crossorigin="anonymous"></script>

      
        
        <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js" integrity="sha256-/BfiIkHlHoVihZdc6TFuj7MmJ0TWcWsMXkeDFwhi0zw=" crossorigin="anonymous"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/python.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/r.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/bash.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/css.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/diff.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/javascript.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/json.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/markdown.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/nginx.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/processing.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/scala.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/sql.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/tex.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/vim.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/yaml.min.js"></script>
        
      

      
      
      <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.4/MathJax.js?config=TeX-AMS_CHTML-full" integrity="sha256-GhM+5JHb6QUzOQPXSJLEWP7R73CbkisjzK5Eyij4U9w=" crossorigin="anonymous" async></script>
      
    

    <script src="/js/hugo-academic.js"></script>
    

    
    

    
    
    
    <script id="dsq-count-scr" src="//ackso-net.disqus.com.disqus.com/count.js" async></script>
    

    
    
    <script>hljs.initHighlightingOnLoad();</script>
    

    
    
    <script>
      const search_index_filename = "/index.json";
      const i18n = {
        'placeholder': "Search...",
        'results': "Search Results",
        'no_results': "No results found"
      };
      const content_type = {
        'post': "Posts",
        'project': "Projects",
        'publication' : "Publications",
        'talk' : "Talks"
        };
    </script>
    

    
    

    

    
    

    
    

  </body>
</html>

